# coding: utf-8

"""
    VRt.Routing [RO]

    # Description  **VRt.Routing** is designed to find a route between locations and build time-distance matrices.  ## Features  * Getting the distance and time between two locations, including traffic jams * Finding a route between specified locations * Creating a time-distance matrix  ## Entity relationship diagram  ![erd](../uml/routing.svg)  # noqa: E501

    The version of the OpenAPI document: 5.12.1831
    Contact: servicedesk@veeroute.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from vrt_lss_routing import schemas  # noqa: F401


class MatrixTask(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Task for calculating a matrix. The departure time considers traffic jams.
    """


    class MetaOapg:
        required = {
            "waypoints",
        }
        
        class properties:
            
            
            class waypoints(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    unique_items = False
                    max_items = 30001
                    min_items = 2
                    
                    @staticmethod
                    def items() -> typing.Type['Waypoint']:
                        return Waypoint
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['Waypoint'], typing.List['Waypoint']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'waypoints':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'Waypoint':
                    return super().__getitem__(i)
        
            @staticmethod
            def transport_type() -> typing.Type['TransportType']:
                return TransportType
        
            @staticmethod
            def geo_settings() -> typing.Type['GeoSettings']:
                return GeoSettings
            
            
            class departure_time(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'departure_time':
                    return super().__new__(
                        cls,
                        *args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "waypoints": waypoints,
                "transport_type": transport_type,
                "geo_settings": geo_settings,
                "departure_time": departure_time,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    waypoints: MetaOapg.properties.waypoints
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["waypoints"]) -> MetaOapg.properties.waypoints: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["transport_type"]) -> 'TransportType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["geo_settings"]) -> 'GeoSettings': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["departure_time"]) -> MetaOapg.properties.departure_time: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["waypoints"], typing_extensions.Literal["transport_type"], typing_extensions.Literal["geo_settings"], typing_extensions.Literal["departure_time"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["waypoints"]) -> MetaOapg.properties.waypoints: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["transport_type"]) -> typing.Union['TransportType', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["geo_settings"]) -> typing.Union['GeoSettings', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["departure_time"]) -> typing.Union[MetaOapg.properties.departure_time, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["waypoints"], typing_extensions.Literal["transport_type"], typing_extensions.Literal["geo_settings"], typing_extensions.Literal["departure_time"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        waypoints: typing.Union[MetaOapg.properties.waypoints, list, tuple, ],
        transport_type: typing.Union['TransportType', schemas.Unset] = schemas.unset,
        geo_settings: typing.Union['GeoSettings', schemas.Unset] = schemas.unset,
        departure_time: typing.Union[MetaOapg.properties.departure_time, None, str, datetime, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'MatrixTask':
        return super().__new__(
            cls,
            *args,
            waypoints=waypoints,
            transport_type=transport_type,
            geo_settings=geo_settings,
            departure_time=departure_time,
            _configuration=_configuration,
        )

from vrt_lss_routing.model.geo_settings import GeoSettings
from vrt_lss_routing.model.transport_type import TransportType
from vrt_lss_routing.model.waypoint import Waypoint
