# coding: utf-8

"""
    VRt.Routing [RO]

    # Description  **VRt.Routing** is designed to find a route between locations and build time-distance matrices.  ## Features  * Getting the distance and time between two locations, including traffic jams * Finding a route between specified locations * Creating a time-distance matrix  ## Entity relationship diagram  ![erd](../uml/routing.svg)  # noqa: E501

    The version of the OpenAPI document: 5.12.1831
    Contact: servicedesk@veeroute.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from vrt_lss_routing import schemas  # noqa: F401


class RoutingMatrix(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Time and distance matrix.
    """


    class MetaOapg:
        required = {
            "distances",
            "durations",
            "waypoints",
        }
        
        class properties:
            
            
            class waypoints(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    unique_items = False
                    max_items = 30001
                    min_items = 2
                    
                    @staticmethod
                    def items() -> typing.Type['Waypoint']:
                        return Waypoint
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['Waypoint'], typing.List['Waypoint']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'waypoints':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'Waypoint':
                    return super().__getitem__(i)
            
            
            class distances(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    unique_items = False
                    max_items = 30001
                    min_items = 2
                    
                    @staticmethod
                    def items() -> typing.Type['RoutingMatrixLine']:
                        return RoutingMatrixLine
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['RoutingMatrixLine'], typing.List['RoutingMatrixLine']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'distances':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'RoutingMatrixLine':
                    return super().__getitem__(i)
            
            
            class durations(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    unique_items = False
                    max_items = 30001
                    min_items = 2
                    
                    @staticmethod
                    def items() -> typing.Type['RoutingMatrixLine']:
                        return RoutingMatrixLine
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['RoutingMatrixLine'], typing.List['RoutingMatrixLine']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'durations':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'RoutingMatrixLine':
                    return super().__getitem__(i)
            __annotations__ = {
                "waypoints": waypoints,
                "distances": distances,
                "durations": durations,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    distances: MetaOapg.properties.distances
    durations: MetaOapg.properties.durations
    waypoints: MetaOapg.properties.waypoints
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["distances"]) -> MetaOapg.properties.distances: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["durations"]) -> MetaOapg.properties.durations: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["waypoints"]) -> MetaOapg.properties.waypoints: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["distances"], typing_extensions.Literal["durations"], typing_extensions.Literal["waypoints"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["distances"]) -> MetaOapg.properties.distances: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["durations"]) -> MetaOapg.properties.durations: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["waypoints"]) -> MetaOapg.properties.waypoints: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["distances"], typing_extensions.Literal["durations"], typing_extensions.Literal["waypoints"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        distances: typing.Union[MetaOapg.properties.distances, list, tuple, ],
        durations: typing.Union[MetaOapg.properties.durations, list, tuple, ],
        waypoints: typing.Union[MetaOapg.properties.waypoints, list, tuple, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'RoutingMatrix':
        return super().__new__(
            cls,
            *args,
            distances=distances,
            durations=durations,
            waypoints=waypoints,
            _configuration=_configuration,
        )

from vrt_lss_routing.model.routing_matrix_line import RoutingMatrixLine
from vrt_lss_routing.model.waypoint import Waypoint
